<HTML>
<BODY BGCOLOR="white">
<PRE>
<FONT color="green">001</FONT>    /*<a name="line.1"></a>
<FONT color="green">002</FONT>     * =============================================================================<a name="line.2"></a>
<FONT color="green">003</FONT>     * Simplified BSD License, see http://www.opensource.org/licenses/<a name="line.3"></a>
<FONT color="green">004</FONT>     * -----------------------------------------------------------------------------<a name="line.4"></a>
<FONT color="green">005</FONT>     * Copyright (c) 2008-2009, Marco Terzer, Zurich, Switzerland<a name="line.5"></a>
<FONT color="green">006</FONT>     * All rights reserved.<a name="line.6"></a>
<FONT color="green">007</FONT>     * <a name="line.7"></a>
<FONT color="green">008</FONT>     * Redistribution and use in source and binary forms, with or without <a name="line.8"></a>
<FONT color="green">009</FONT>     * modification, are permitted provided that the following conditions are met:<a name="line.9"></a>
<FONT color="green">010</FONT>     * <a name="line.10"></a>
<FONT color="green">011</FONT>     *     * Redistributions of source code must retain the above copyright notice, <a name="line.11"></a>
<FONT color="green">012</FONT>     *       this list of conditions and the following disclaimer.<a name="line.12"></a>
<FONT color="green">013</FONT>     *     * Redistributions in binary form must reproduce the above copyright <a name="line.13"></a>
<FONT color="green">014</FONT>     *       notice, this list of conditions and the following disclaimer in the <a name="line.14"></a>
<FONT color="green">015</FONT>     *       documentation and/or other materials provided with the distribution.<a name="line.15"></a>
<FONT color="green">016</FONT>     *     * Neither the name of the Swiss Federal Institute of Technology Zurich <a name="line.16"></a>
<FONT color="green">017</FONT>     *       nor the names of its contributors may be used to endorse or promote <a name="line.17"></a>
<FONT color="green">018</FONT>     *       products derived from this software without specific prior written <a name="line.18"></a>
<FONT color="green">019</FONT>     *       permission.<a name="line.19"></a>
<FONT color="green">020</FONT>     * <a name="line.20"></a>
<FONT color="green">021</FONT>     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" <a name="line.21"></a>
<FONT color="green">022</FONT>     * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE <a name="line.22"></a>
<FONT color="green">023</FONT>     * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE <a name="line.23"></a>
<FONT color="green">024</FONT>     * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE <a name="line.24"></a>
<FONT color="green">025</FONT>     * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR <a name="line.25"></a>
<FONT color="green">026</FONT>     * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF <a name="line.26"></a>
<FONT color="green">027</FONT>     * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS <a name="line.27"></a>
<FONT color="green">028</FONT>     * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN <a name="line.28"></a>
<FONT color="green">029</FONT>     * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) <a name="line.29"></a>
<FONT color="green">030</FONT>     * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE <a name="line.30"></a>
<FONT color="green">031</FONT>     * POSSIBILITY OF SUCH DAMAGE.<a name="line.31"></a>
<FONT color="green">032</FONT>     * =============================================================================<a name="line.32"></a>
<FONT color="green">033</FONT>     */<a name="line.33"></a>
<FONT color="green">034</FONT>    package ch.javasoft.jsmat.variable;<a name="line.34"></a>
<FONT color="green">035</FONT>    <a name="line.35"></a>
<FONT color="green">036</FONT>    import java.io.ByteArrayOutputStream;<a name="line.36"></a>
<FONT color="green">037</FONT>    import java.io.DataOutput;<a name="line.37"></a>
<FONT color="green">038</FONT>    import java.io.DataOutputStream;<a name="line.38"></a>
<FONT color="green">039</FONT>    import java.io.IOException;<a name="line.39"></a>
<FONT color="green">040</FONT>    import java.util.Arrays;<a name="line.40"></a>
<FONT color="green">041</FONT>    import java.util.Map;<a name="line.41"></a>
<FONT color="green">042</FONT>    <a name="line.42"></a>
<FONT color="green">043</FONT>    import ch.javasoft.jsmat.common.MatClass;<a name="line.43"></a>
<FONT color="green">044</FONT>    import ch.javasoft.jsmat.common.MatType;<a name="line.44"></a>
<FONT color="green">045</FONT>    import ch.javasoft.jsmat.primitive.MatInt8;<a name="line.45"></a>
<FONT color="green">046</FONT>    <a name="line.46"></a>
<FONT color="green">047</FONT>    public class MatStructure extends MatAllocated {<a name="line.47"></a>
<FONT color="green">048</FONT>            <a name="line.48"></a>
<FONT color="green">049</FONT>            private final Map&lt;String, ? extends MatAllocated&gt;[] mFields;<a name="line.49"></a>
<FONT color="green">050</FONT>            <a name="line.50"></a>
<FONT color="green">051</FONT>            @SuppressWarnings("unchecked")<a name="line.51"></a>
<FONT color="green">052</FONT>            public MatStructure(Map&lt;String, ? extends MatAllocated&gt; fields) {<a name="line.52"></a>
<FONT color="green">053</FONT>                    this(new Map[] {fields}, new int[] {1, 1});<a name="line.53"></a>
<FONT color="green">054</FONT>            }<a name="line.54"></a>
<FONT color="green">055</FONT>    <a name="line.55"></a>
<FONT color="green">056</FONT>            public MatStructure(Map&lt;String, ? extends MatAllocated&gt;[] fields, int[] dims) {<a name="line.56"></a>
<FONT color="green">057</FONT>                    super(MatClass.STRUCT, dims);<a name="line.57"></a>
<FONT color="green">058</FONT>                    mFields = fields;<a name="line.58"></a>
<FONT color="green">059</FONT>                    checkMapSizesEqual();<a name="line.59"></a>
<FONT color="green">060</FONT>                    checkValueLength(fields.length);<a name="line.60"></a>
<FONT color="green">061</FONT>            }<a name="line.61"></a>
<FONT color="green">062</FONT>    <a name="line.62"></a>
<FONT color="green">063</FONT>            private void checkMapSizesEqual() {<a name="line.63"></a>
<FONT color="green">064</FONT>                    if (mFields.length == 0) return;<a name="line.64"></a>
<FONT color="green">065</FONT>                    final int unit = mFields[0].size();<a name="line.65"></a>
<FONT color="green">066</FONT>            for (int i = 1; i &lt; mFields.length; i++) {<a name="line.66"></a>
<FONT color="green">067</FONT>                            if (unit != mFields[i].size()) {<a name="line.67"></a>
<FONT color="green">068</FONT>                                    throw new IllegalArgumentException("not all field maps have same size");<a name="line.68"></a>
<FONT color="green">069</FONT>                            }<a name="line.69"></a>
<FONT color="green">070</FONT>                    }<a name="line.70"></a>
<FONT color="green">071</FONT>            }<a name="line.71"></a>
<FONT color="green">072</FONT>    <a name="line.72"></a>
<FONT color="green">073</FONT>            @Override<a name="line.73"></a>
<FONT color="green">074</FONT>            public int getRawDataSize() {<a name="line.74"></a>
<FONT color="green">075</FONT>                    return getRawDataSize(mFields);<a name="line.75"></a>
<FONT color="green">076</FONT>            }<a name="line.76"></a>
<FONT color="green">077</FONT>            <a name="line.77"></a>
<FONT color="green">078</FONT>            static int getRawDataSize(Map&lt;String, ? extends MatVariable&gt;[] fields) {<a name="line.78"></a>
<FONT color="green">079</FONT>                    int size = 0;<a name="line.79"></a>
<FONT color="green">080</FONT>            size += 4;//itag<a name="line.80"></a>
<FONT color="green">081</FONT>            size += 4;//max field name length<a name="line.81"></a>
<FONT color="green">082</FONT>            size += new MatInt8(getFieldNamesAsByteArray(fields)).getSize();<a name="line.82"></a>
<FONT color="green">083</FONT>            for (int i = 0; i &lt; fields.length; i++) {<a name="line.83"></a>
<FONT color="green">084</FONT>                            for (String name : fields[i].keySet()) {<a name="line.84"></a>
<FONT color="green">085</FONT>                                    MatVariable mx = fields[i].get(name);<a name="line.85"></a>
<FONT color="green">086</FONT>                                    size += mx.getSize(name);//or real field name?<a name="line.86"></a>
<FONT color="green">087</FONT>                            }<a name="line.87"></a>
<FONT color="green">088</FONT>                    }<a name="line.88"></a>
<FONT color="green">089</FONT>            return size;<a name="line.89"></a>
<FONT color="green">090</FONT>            }<a name="line.90"></a>
<FONT color="green">091</FONT>    <a name="line.91"></a>
<FONT color="green">092</FONT>            @Override<a name="line.92"></a>
<FONT color="green">093</FONT>            public void writeRawData(DataOutput out) throws IOException {<a name="line.93"></a>
<FONT color="green">094</FONT>                    writeStructStart(out, mFields);<a name="line.94"></a>
<FONT color="green">095</FONT>            for (int i = 0; i &lt; mFields.length; i++) {<a name="line.95"></a>
<FONT color="green">096</FONT>                            for (String name : mFields[i].keySet()) {<a name="line.96"></a>
<FONT color="green">097</FONT>                                    MatAllocated mx = mFields[i].get(name);<a name="line.97"></a>
<FONT color="green">098</FONT>                                    mx.write(name, out);<a name="line.98"></a>
<FONT color="green">099</FONT>                            }<a name="line.99"></a>
<FONT color="green">100</FONT>                    }<a name="line.100"></a>
<FONT color="green">101</FONT>            }<a name="line.101"></a>
<FONT color="green">102</FONT>            <a name="line.102"></a>
<FONT color="green">103</FONT>            static void writeStructStart(DataOutput out, Map&lt;String, ? extends MatVariable&gt;[] fields) throws IOException {<a name="line.103"></a>
<FONT color="green">104</FONT>            int itag = 4 &lt;&lt; 16 | MatType.INT32.type &amp; 0xffff;<a name="line.104"></a>
<FONT color="green">105</FONT>            out.writeInt(itag);<a name="line.105"></a>
<FONT color="green">106</FONT>            out.writeInt(getMaxFieldNameLength(fields));<a name="line.106"></a>
<FONT color="green">107</FONT>            new MatInt8(getFieldNamesAsByteArray(fields)).write(out);<a name="line.107"></a>
<FONT color="green">108</FONT>            }<a name="line.108"></a>
<FONT color="green">109</FONT>            <a name="line.109"></a>
<FONT color="green">110</FONT>    <a name="line.110"></a>
<FONT color="green">111</FONT>        /**<a name="line.111"></a>
<FONT color="green">112</FONT>         * Dumps field names to byte array. Field names are written as Zero End Strings<a name="line.112"></a>
<FONT color="green">113</FONT>         */<a name="line.113"></a>
<FONT color="green">114</FONT>        private static byte[] getFieldNamesAsByteArray(Map&lt;String, ? extends MatVariable&gt;[] fields) <a name="line.114"></a>
<FONT color="green">115</FONT>        {<a name="line.115"></a>
<FONT color="green">116</FONT>            ByteArrayOutputStream baos = new ByteArrayOutputStream();<a name="line.116"></a>
<FONT color="green">117</FONT>            DataOutputStream dos = new DataOutputStream(baos);<a name="line.117"></a>
<FONT color="green">118</FONT>            <a name="line.118"></a>
<FONT color="green">119</FONT>            char[] buffer = new char[getMaxFieldNameLength(fields)];<a name="line.119"></a>
<FONT color="green">120</FONT>            <a name="line.120"></a>
<FONT color="green">121</FONT>            try {<a name="line.121"></a>
<FONT color="green">122</FONT>                for (int i = 0; i &lt; fields.length; i++) {<a name="line.122"></a>
<FONT color="green">123</FONT>                            for (String name : fields[i].keySet()) {<a name="line.123"></a>
<FONT color="green">124</FONT>                        Arrays.fill(buffer, (char)0);<a name="line.124"></a>
<FONT color="green">125</FONT>                        System.arraycopy(name.toCharArray(), 0, buffer, 0, name.length());<a name="line.125"></a>
<FONT color="green">126</FONT>                        dos.writeBytes(new String(buffer));<a name="line.126"></a>
<FONT color="green">127</FONT>                            }<a name="line.127"></a>
<FONT color="green">128</FONT>                    }<a name="line.128"></a>
<FONT color="green">129</FONT>            }<a name="line.129"></a>
<FONT color="green">130</FONT>            catch  (IOException ex) {<a name="line.130"></a>
<FONT color="green">131</FONT>               throw new RuntimeException(ex);<a name="line.131"></a>
<FONT color="green">132</FONT>            }<a name="line.132"></a>
<FONT color="green">133</FONT>            return baos.toByteArray();        <a name="line.133"></a>
<FONT color="green">134</FONT>        }<a name="line.134"></a>
<FONT color="green">135</FONT>    <a name="line.135"></a>
<FONT color="green">136</FONT>            private static int getMaxFieldNameLength(Map&lt;String, ? extends MatVariable&gt;[] fields) {<a name="line.136"></a>
<FONT color="green">137</FONT>                    int len = Integer.MIN_VALUE;<a name="line.137"></a>
<FONT color="green">138</FONT>            for (int i = 0; i &lt; fields.length; i++) {<a name="line.138"></a>
<FONT color="green">139</FONT>                            for (String name : fields[i].keySet()) {<a name="line.139"></a>
<FONT color="green">140</FONT>                                    len = Math.max(len, name.length());<a name="line.140"></a>
<FONT color="green">141</FONT>                            }<a name="line.141"></a>
<FONT color="green">142</FONT>                    }<a name="line.142"></a>
<FONT color="green">143</FONT>            return len + 1;<a name="line.143"></a>
<FONT color="green">144</FONT>            }<a name="line.144"></a>
<FONT color="green">145</FONT>    <a name="line.145"></a>
<FONT color="green">146</FONT>    //      private static byte[] getNameBytes(String name) {<a name="line.146"></a>
<FONT color="green">147</FONT>    //              try {<a name="line.147"></a>
<FONT color="green">148</FONT>    //                      return name.getBytes("UTF-8");<a name="line.148"></a>
<FONT color="green">149</FONT>    //              }<a name="line.149"></a>
<FONT color="green">150</FONT>    //              catch (UnsupportedEncodingException ex) {<a name="line.150"></a>
<FONT color="green">151</FONT>    //                      throw new RuntimeException(ex);<a name="line.151"></a>
<FONT color="green">152</FONT>    //              }<a name="line.152"></a>
<FONT color="green">153</FONT>    //      }<a name="line.153"></a>
<FONT color="green">154</FONT>    <a name="line.154"></a>
<FONT color="green">155</FONT>    <a name="line.155"></a>
<FONT color="green">156</FONT>    }<a name="line.156"></a>




























































</PRE>
</BODY>
</HTML>
